
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------




DROP FUNCTION F_KPI_CDR_DEVIATION_MAX;

CREATE OR REPLACE FUNCTION F_KPI_CDR_DEVIATION_MAX (
	V_CP_ID_A IN NUMBER,
	V_CP_ID_B IN NUMBER,
	V_ST_ID IN NUMBER,
	V_ST_PROPERTY IN NUMBER,
	V_DATE IN DATE DEFAULT TRUNC(sysdate-1, 'DD')
  )
RETURN TYPE_KPI_RESULT_ARRAY IS
  V_COUNT_A NUMBER(20,4);
  V_COUNT_B NUMBER(20,4);
  V_CALCULATED_DEVIATION NUMBER(15,4);
  V_CALCULATED_DEVIATION_MAX NUMBER(15,4);
  KPI_RESULT_ARRAY TYPE_KPI_RESULT_ARRAY:=TYPE_KPI_RESULT_ARRAY();
BEGIN
  V_CALCULATED_DEVIATION:=0.0;
  V_CALCULATED_DEVIATION_MAX:=0.0;


IF (V_ST_PROPERTY = 1) THEN
 --- COUNT
  FOR H IN 0..23 LOOP

	  SELECT A.COUNT INTO V_COUNT_A
	  FROM CDR_ALL_SUMMARY A
	  WHERE A.CONTROL_POINT_ID=V_CP_ID_A
	  AND TRUNC(A.TRANS_DT, 'HH24')=TO_DATE(TO_CHAR(V_DATE, 'DD/MM/YYYY') || ' ' || TO_CHAR(H, '00'), 'DD/MM/YYYY HH24')
	  AND A.SERVICE_TYPE_ID=V_ST_ID;

	  SELECT A.COUNT INTO V_COUNT_B
	  FROM CDR_ALL_SUMMARY A
	  WHERE A.CONTROL_POINT_ID=V_CP_ID_B
	  AND TRUNC(A.TRANS_DT, 'HH24')=TO_DATE(TO_CHAR(V_DATE, 'DD/MM/YYYY') || ' ' || TO_CHAR(H, '00'), 'DD/MM/YYYY HH24')
	  AND A.SERVICE_TYPE_ID=V_ST_ID;

	  IF (V_COUNT_A > 0) THEN
		  IF (V_COUNT_B > 0) THEN
			  V_CALCULATED_DEVIATION:=ABS(V_COUNT_A-v_COUNT_B)/GREATEST(V_COUNT_A, V_COUNT_B);
		  ELSE
			  V_CALCULATED_DEVIATION:=1;
		  END IF;
	  ELSE
		IF (V_COUNT_B > 0) THEN
		  V_CALCULATED_DEVIATION:=1;
		END IF;
	  END IF;

	  IF (V_CALCULATED_DEVIATION > V_CALCULATED_DEVIATION_MAX) THEN
		V_CALCULATED_DEVIATION_MAX:=V_CALCULATED_DEVIATION;
	  END IF;

  END LOOP;
END IF;

IF (V_ST_PROPERTY = 2) THEN
 --- DURATION
  FOR H IN 0..23 LOOP

	  SELECT A.DURATION INTO V_COUNT_A
	  FROM CDR_ALL_SUMMARY A
	  WHERE A.CONTROL_POINT_ID=V_CP_ID_A
	  AND TRUNC(A.TRANS_DT, 'HH24')=TO_DATE(TO_CHAR(V_DATE, 'DD/MM/YYYY') || ' ' || TO_CHAR(H, '00'), 'DD/MM/YYYY HH24')
	  AND A.SERVICE_TYPE_ID=V_ST_ID;

	  SELECT A.DURATION INTO V_COUNT_B
	  FROM CDR_ALL_SUMMARY A
	  WHERE A.CONTROL_POINT_ID=V_CP_ID_B
	  AND TRUNC(A.TRANS_DT, 'HH24')=TO_DATE(TO_CHAR(V_DATE, 'DD/MM/YYYY') || ' ' || TO_CHAR(H, '00'), 'DD/MM/YYYY HH24')
	  AND A.SERVICE_TYPE_ID=V_ST_ID;

	  IF (V_COUNT_A > 0) THEN
		  IF (V_COUNT_B > 0) THEN
			  V_CALCULATED_DEVIATION:=ABS(V_COUNT_A-v_COUNT_B)/GREATEST(V_COUNT_A, V_COUNT_B);
		  ELSE
			  V_CALCULATED_DEVIATION:=1;
		  END IF;
	  ELSE
		IF (V_COUNT_B > 0) THEN
		  V_CALCULATED_DEVIATION:=1;
		END IF;
	  END IF;

	  IF (V_CALCULATED_DEVIATION > V_CALCULATED_DEVIATION_MAX) THEN
		V_CALCULATED_DEVIATION_MAX:=V_CALCULATED_DEVIATION;
	  END IF;

  END LOOP;
END IF;

  KPI_RESULT_ARRAY.EXTEND;
  KPI_RESULT_ARRAY(1):=V_CALCULATED_DEVIATION_MAX;

  RETURN KPI_RESULT_ARRAY;

END F_KPI_CDR_DEVIATION_MAX;
/

