
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------




DROP FUNCTION F_KPI_CDR_HAS_BEEN_LOADED;

CREATE OR REPLACE FUNCTION F_KPI_CDR_HAS_BEEN_LOADED (
	V_TABLE IN VARCHAR2,
	V_NOTUSED IN DATE
  )
RETURN TYPE_KPI_RESULT_ARRAY IS
  KPI_RESULT_ARRAY TYPE_KPI_RESULT_ARRAY:=TYPE_KPI_RESULT_ARRAY();
  V_DATE DATE;
  V_LOADED_OK NUMBER(1);
BEGIN
  V_LOADED_OK:=0;

  BEGIN
    SELECT END_TIME INTO V_DATE
    FROM ADM_CDR_LOAD_LOG
    WHERE CONTROL_POINT=V_TABLE
    AND END_TIME IS NOT NULL
    AND TRUNC(END_TIME, 'DD')=TRUNC(SYSDATE, 'DD');

    V_LOADED_OK:=1;

  EXCEPTION
    WHEN NO_DATA_FOUND THEN V_LOADED_OK:=0;

  END;

  KPI_RESULT_ARRAY.EXTEND;
  KPI_RESULT_ARRAY(1):=V_LOADED_OK;

  RETURN KPI_RESULT_ARRAY;

END F_KPI_CDR_HAS_BEEN_LOADED;
/

