
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------




DROP PROCEDURE P_SDR_PLTFRM1_PLTFRM2_COMP;

CREATE OR REPLACE PROCEDURE P_SDR_PLTFRM1_PLTFRM2_COMP (
	LOAD_SAMPLE_PLATFORM IN NUMBER, 
	LOAD_OTHER_PLATFORM  IN NUMBER)
IS
  COMMAND_LINE VARCHAR2(900);
BEGIN

  DELETE RESULT_SDR_PLATFORM1_PLATFORM2
  WHERE SAMPLE_PLATFORM_LOAD_NB=LOAD_SAMPLE_PLATFORM
  AND OTHER_PLATFORM_LOAD_NB=LOAD_OTHER_PLATFORM;

  -- CREATE THE VIEWS THAT WILL BE USED IN THE QUERIES LATER
  COMMAND_LINE:='CREATE OR REPLACE VIEW VIEW_SDR_SAMPLE_PLATFORM AS SELECT * ';
  COMMAND_LINE:=COMMAND_LINE|| 'FROM SDR_LOADS_SAMPLE_PLATFORM WHERE SAMPLE_PLATFORM_LOAD_NB=' || TO_CHAR(LOAD_SAMPLE_PLATFORM);
  EXECUTE IMMEDIATE COMMAND_LINE;

  COMMAND_LINE:='CREATE OR REPLACE VIEW VIEW_SDR_OTHER_PLATFORM AS SELECT * ';
  COMMAND_LINE:=COMMAND_LINE|| 'FROM SDR_LOADS_OTHER_PLATFORM WHERE OTHER_PLATFORM_LOAD_NB=' || TO_CHAR(LOAD_OTHER_PLATFORM);
  EXECUTE IMMEDIATE COMMAND_LINE;


  INSERT INTO RESULT_SDR_PLATFORM1_PLATFORM2  (
		SAMPLE_PLATFORM_LOAD_NB,  
		OTHER_PLATFORM_LOAD_NB,
		KEY_FIELD_1,
		P1_FIELD_2,
	     --...
		P1_FIELD_N
		)
  SELECT   LOAD_SAMPLE_PLATFORM, 
	   LOAD_OTHER_PLATFORM,
	   FIELD_1,
	   FIELD_2,
	 --...
	   FIELD_N
  FROM VIEW_SDR_SAMPLE_PLATFORM;


  UPDATE RESULT_SDR_PLATFORM1_PLATFORM2
  SET (
	P2_FIELD_2,
     --...
	P2_FIELD_N
    )=(
     SELECT
		FIELD_2,
	     --...
		FIELD_N
     FROM VIEW_SDR_OTHER_PLATFORM
     WHERE FIELD_1=RESULT_SDR_PLATFORM1_PLATFORM2.KEY_FIELD_1
  )
  WHERE EXISTS (
    SELECT FIELD_1
    FROM VIEW_SDR_OTHER_PLATFORM
    WHERE FIELD_1=RESULT_SDR_PLATFORM1_PLATFORM2.KEY_FIELD_1 
  )
  AND SAMPLE_PLATFORM_LOAD_NB=LOAD_SAMPLE_PLATFORM
  AND OTHER_PLATFORM_LOAD_NB=LOAD_OTHER_PLATFORM;


  INSERT INTO RESULT_SDR_PLATFORM1_PLATFORM2  (
		SAMPLE_PLATFORM_LOAD_NB,  
		OTHER_PLATFORM_LOAD_NB,
		KEY_FIELD_1,
		P2_FIELD_2,
	     --...
		P2_FIELD_N
		)
     SELECT 
	LOAD_SAMPLE_PLATFORM, 
	LOAD_OTHER_PLATFORM, 
	FIELD_1,
	FIELD_2,
      --...
       FIELD_N
     FROM VIEW_SDR_OTHER_PLATFORM
     WHERE NOT EXISTS (
	SELECT KEY_FIELD_1
	FROM RESULT_SDR_PLATFORM1_PLATFORM2 
	WHERE KEY_FIELD_1=VIEW_SDR_OTHER_PLATFORM.FIELD_1 
	AND SAMPLE_PLATFORM_LOAD_NB=LOAD_SAMPLE_PLATFORM
	AND OTHER_PLATFORM_LOAD_NB=LOAD_OTHER_PLATFORM
     );


  UPDATE RESULT_SDR_PLATFORM1_PLATFORM2
  SET HAS_ERROR1=1
  WHERE SAMPLE_PLATFORM_LOAD_NB=LOAD_SAMPLE_PLATFORM
  AND OTHER_PLATFORM_LOAD_NB=LOAD_OTHER_PLATFORM
  AND (
	-- Business Rules to detect Error #1
	0=1  
  );

  UPDATE RESULT_SDR_PLATFORM1_PLATFORM2
  SET HAS_ERROR2=1
  WHERE SAMPLE_PLATFORM_LOAD_NB=LOAD_SAMPLE_PLATFORM
  AND OTHER_PLATFORM_LOAD_NB=LOAD_OTHER_PLATFORM
  AND (
	-- Business Rules to detect Error #2
	0=1  
  );

--...


  UPDATE RESULT_SDR_PLATFORM1_PLATFORM2
  SET HAS_ERRORN=1
  WHERE SAMPLE_PLATFORM_LOAD_NB=LOAD_SAMPLE_PLATFORM
  AND OTHER_PLATFORM_LOAD_NB=LOAD_OTHER_PLATFORM
  AND (
	-- Business Rules to detect Error #N
	0=1  
  );


END;
/