
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------




DROP PROCEDURE P_CDR_CALC_SUM_AVG;

CREATE OR REPLACE PROCEDURE P_CDR_CALC_SUM_AVG (
	V_TABLE IN VARCHAR2)
IS
  COMMAND_LINE VARCHAR2(600);
  TYPE T_DYN_CURSOR IS REF CURSOR;
  C2 T_DYN_CURSOR;
  CURSOR C3 (PARAM_TABLE VARCHAR2) IS 
	SELECT CONTROL_POINT_ID
	FROM REF_CDR_CONTROL_POINTS
	WHERE TABLE_NAME=PARAM_TABLE;
  V_WEEK VARCHAR2(1);
  V_DAY VARCHAR2(1);
  V_HOUR VARCHAR2(2);
  V_COUNT NUMBER(30); 
  V_DURATION NUMBER(30);
  V_VALUE NUMBER(30);
  V_SERVICE_TYPE_ID NUMBER(3);
  V_CONTROL_POINT_ID NUMBER(3);
  V_MAX_DATE VARCHAR2(20);
BEGIN
    OPEN C3(V_TABLE);
    FETCH C3 INTO V_CONTROL_POINT_ID;
    CLOSE C3;

    DELETE CDR_ALL_SUMMARY_AVG
    WHERE CONTROL_POINT_ID=V_CONTROL_POINT_ID;

    SELECT TO_CHAR(MAX(TRANS_DT), 'DD/MM/YYYY HH24:MI:SS') INTO V_MAX_DATE
    FROM CDR_ALL_SUMMARY 
    WHERE CONTROL_POINT_ID=V_CONTROL_POINT_ID
    AND COUNT>0;

    COMMAND_LINE:='SELECT SERVICE_TYPE_ID, TO_CHAR(TRANS_DT, ''W'') "W", TO_CHAR(TRANS_DT, ''D'') "D", TO_CHAR(TRANS_DT, ''HH24'') "H", ';
    COMMAND_LINE:=COMMAND_LINE || ' NVL(FLOOR(AVG(COUNT)), 0), NVL(FLOOR(AVG(DURATION)), 0), NVL(FLOOR(AVG(VALUE)), 0) ';
    COMMAND_LINE:=COMMAND_LINE || 'FROM CDR_ALL_SUMMARY ';
    COMMAND_LINE:=COMMAND_LINE || ' WHERE CONTROL_POINT_ID=' || TO_CHAR(V_CONTROL_POINT_ID);
    COMMAND_LINE:=COMMAND_LINE || ' AND TRUNC(TRANS_DT, ''DD'') NOT IN (SELECT SPECIAL_DAY FROM REF_CDR_SPECIAL_DAYS) ';
    COMMAND_LINE:=COMMAND_LINE || ' AND TRANS_DT <=  TO_DATE(''' || V_MAX_DATE || ''', ''DD/MM/YYYY HH24:MI:SS'') ';
    COMMAND_LINE:=COMMAND_LINE || ' AND COUNT > 0';
    COMMAND_LINE:=COMMAND_LINE || ' GROUP BY SERVICE_TYPE_ID, TO_CHAR(TRANS_DT, ''W''), TO_CHAR(TRANS_DT, ''D''), TO_CHAR(TRANS_DT, ''HH24'') ';

    OPEN C2 FOR COMMAND_LINE;
    LOOP

      FETCH C2 INTO V_SERVICE_TYPE_ID, V_WEEK, V_DAY, V_HOUR, V_COUNT, V_DURATION, V_VALUE;
      EXIT WHEN C2%NOTFOUND;

      INSERT INTO CDR_ALL_SUMMARY_AVG (
		CONTROL_POINT_ID,
		WEEK_OF_MONTH,
		DAY_OF_WEEK,
		HOUR_OF_DAY,
		SERVICE_TYPE_ID,
		COUNT,
		DURATION,
		VALUE)
      VALUES(	V_CONTROL_POINT_ID,
		V_WEEK,
		V_DAY,
		V_HOUR,
		V_SERVICE_TYPE_ID,
		V_COUNT,
	  	V_DURATION,
	  	V_VALUE);

    END LOOP;
    CLOSE C2;

END;
/

