
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------




DROP PROCEDURE P_CDR_INIT_SUMMARY;

CREATE OR REPLACE PROCEDURE P_CDR_INIT_SUMMARY (
		V_YEAR IN VARCHAR2, 
		V_MONTH IN VARCHAR2, 
		V_SERVICE_TYPE_ID IN NUMBER DEFAULT -1,
		V_CONTROL_POINT_ID IN NUMBER DEFAULT -1)
IS
  CURSOR C1(V_CP_ID NUMBER) IS 
		SELECT CONTROL_POINT_ID
		FROM REF_CDR_CONTROL_POINTS
		WHERE    V_CP_ID=-1 
		      OR ((V_CP_ID > 0) AND (CONTROL_POINT_ID=V_CP_ID));

  CURSOR C2(V_CP_ID NUMBER, V_ST_ID NUMBER) IS 
		SELECT A.SERVICE_TYPE_ID, B.INTERVAL
		FROM REF_CDR_ST_MATRIX A, REF_CDR_SERVICE_TYPES B
		WHERE A.CONTROL_POINT_ID=V_CP_ID
		   AND A.SERVICE_TYPE_ID=B.SERVICE_TYPE_ID
		   AND (    (V_ST_ID=-1) 
		   	 OR ((V_ST_ID > 0) AND (A.SERVICE_TYPE_ID=V_ST_ID))
			);
  NB_DAYS NUMBER(2);
BEGIN
  NB_DAYS:=TO_NUMBER(TO_CHAR(LAST_DAY(TO_DATE(V_YEAR || V_MONTH || '01', 'YYYYMMDD')), 'DD'));
  FOR X IN C1(V_CONTROL_POINT_ID) LOOP
    FOR Y IN C2(X.CONTROL_POINT_ID, V_SERVICE_TYPE_ID) LOOP
      FOR D IN 1..NB_DAYS LOOP
	IF (Y.INTERVAL = 'H') THEN
           FOR H IN 0..23 LOOP
		INSERT INTO CDR_ALL_SUMMARY (
	    		CONTROL_POINT_ID, 
		    	TRANS_DT, 
	    		SERVICE_TYPE_ID, 
	    		COUNT, 
	    		DURATION, 
	    		VALUE)
	  	VALUES (
			X.CONTROL_POINT_ID,
			TO_DATE(V_YEAR || V_MONTH || TO_CHAR(D, '00') || ' ' || TO_CHAR(H, '00') || ':00:00', 'YYYYMMDD HH24:MI:SS'),
			Y.SERVICE_TYPE_ID,
			0,
			0,
			0);
           END LOOP;
	ELSE
		INSERT INTO CDR_ALL_SUMMARY (
	    		CONTROL_POINT_ID, 
		    	TRANS_DT, 
	    		SERVICE_TYPE_ID, 
	    		COUNT, 
	    		DURATION, 
	    		VALUE)
	  	VALUES (
			X.CONTROL_POINT_ID,
			TO_DATE(V_YEAR || V_MONTH || TO_CHAR(D, '00') || ' ' || '00:00:00', 'YYYYMMDD HH24:MI:SS'),
			Y.SERVICE_TYPE_ID,
			0,
			0,
			0);
	END IF;
      END LOOP;
    END LOOP;
  END LOOP;
  COMMIT;
END;
/