
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------



DROP PROCEDURE P_CDR_INSERT_JOB_COMPARE;

CREATE OR REPLACE PROCEDURE P_CDR_INSERT_JOB_COMPARE(
  	V_JOB_ID IN NUMBER,
	V_TABLE_A IN VARCHAR2,
	V_TABLE_B IN VARCHAR2,
	V_TRANS_DT_MIN IN DATE,
	V_TRANS_DT_MAX IN DATE,
	V_SERVICE_TYPE_ID IN NUMBER,
	V_TOLERANCE IN NUMBER DEFAULT 0,
	V_DESCRIPTION IN VARCHAR2 DEFAULT 'Inserted by script'
)
IS 
  COMMAND_LINE VARCHAR2(3000);
  JOB_ID NUMBER(8);
BEGIN

  COMMAND_LINE:='INSERT INTO RESULT_CDR_SUMMARY (JOB_ID, JOB_NAME, CREATED_WHO, CREATED_DT, TABLE_A, TABLE_B, ';
  COMMAND_LINE:=COMMAND_LINE || 'TRANS_DT_MIN, TRANS_DT_MAX, SERVICE_TYPE_ID, TOLERANCE, JOB_STATUS, ';
  COMMAND_LINE:=COMMAND_LINE || ' IN_A_AND_B, IN_A_NOT_B, IN_B_NOT_A) ';
  COMMAND_LINE:=COMMAND_LINE || 'VALUES (' || TO_CHAR(V_JOB_ID) || ', ';
  COMMAND_LINE:=COMMAND_LINE || '''' || V_DESCRIPTION || ''', ';
  COMMAND_LINE:=COMMAND_LINE || '''Script'', sysdate, ';
  COMMAND_LINE:=COMMAND_LINE || '''' || V_TABLE_A || ''', ';
  COMMAND_LINE:=COMMAND_LINE || '''' || V_TABLE_B || ''', ';
  COMMAND_LINE:=COMMAND_LINE || 'TO_DATE(''';
  COMMAND_LINE:=COMMAND_LINE || TO_CHAR(V_TRANS_DT_MIN, 'DD/MM/YYYY HH24:MI:SS');
  COMMAND_LINE:=COMMAND_LINE || ''', ''DD/MM/YYYY HH24:MI:SS''), ';
  COMMAND_LINE:=COMMAND_LINE || 'TO_DATE(''';
  COMMAND_LINE:=COMMAND_LINE || TO_CHAR(V_TRANS_DT_MAX, 'DD/MM/YYYY HH24:MI:SS');
  COMMAND_LINE:=COMMAND_LINE || ''', ''DD/MM/YYYY HH24:MI:SS''), ' || TO_CHAR(V_SERVICE_TYPE_ID) || ', ';
  COMMAND_LINE:=COMMAND_LINE || TO_CHAR(V_TOLERANCE) || ', 1, 0, 0, 0)';

  EXECUTE IMMEDIATE COMMAND_LINE;

  COMMIT;

END;
/

