
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------



DROP PROCEDURE P_CDR_PURGE;

CREATE OR REPLACE PROCEDURE P_CDR_PURGE (
	V_TABLE IN VARCHAR2)
IS
  COMMAND_LINE VARCHAR2(50);
  TYPE T_DYN_CURSOR IS REF CURSOR;
  C1 T_DYN_CURSOR;
  V_COUNT NUMBER(9);
  RESOURCE_BUSY EXCEPTION;
  V_ATTEMPTS NUMBER(2);
  V_SUCCESS NUMBER(1);
  PRAGMA EXCEPTION_INIT(RESOURCE_BUSY, -54);
BEGIN

 V_COUNT:=0;
 V_ATTEMPTS:=1;
 V_SUCCESS:=0;

 -- VERIFY THAT THE TABLE HAS BEEN PURGED BY THE LOADING SCRIPT
 -- IF NOT, TRUNCATE

 COMMAND_LINE:='SELECT COUNT(*) FROM LOAD_CDR_' || V_TABLE;

 OPEN C1 FOR COMMAND_LINE;
 LOOP
    BEGIN
      FETCH C1 INTO V_COUNT;
    EXCEPTION
	 WHEN NO_DATA_FOUND THEN
	    V_COUNT:=0;
    END;
    EXIT WHEN C1%NOTFOUND;
 END LOOP;
 CLOSE C1;

 IF (V_COUNT >= 1) THEN

     -- THERE ARE ROWS. TRUNCATE TABLE

   LOOP 

      BEGIN

	 COMMAND_LINE:='TRUNCATE TABLE LOAD_CDR_' || V_TABLE;
	 EXECUTE IMMEDIATE COMMAND_LINE;

	 V_SUCCESS:=1;

      EXCEPTION

	 WHEN RESOURCE_BUSY THEN
		IF (V_ATTEMPTS < 20) THEN
			SYS.DBMS_LOCK.SLEEP (300*V_ATTEMPTS);
			V_ATTEMPTS:=V_ATTEMPTS+1;
		END IF;
      END;

      EXIT WHEN ((V_SUCCESS=1) OR (V_ATTEMPTS>=20));

   END LOOP;

 ELSE
    V_SUCCESS:=1;
 END IF;

 IF (V_SUCCESS=0) THEN
	RAISE RESOURCE_BUSY;
 END IF;
END;
/